



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>《机器学习实战》学习笔记——第2章 KNN</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">《机器学习实战》学习笔记——第2章 KNN</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 05:58:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一. KNN原理：</h2>
<h3>1. 有监督的学习</h3>
<p>根据已知事例及其类标，对新的实例按照离他最近的K的邻居中出现频率最高的类别进行分类。伪代码如下：</p>
<p>　　1）计算已知类别数据集中的点与当前点之间的距离</p>
<p>　　2）按照距离从小到大排序</p>
<p>　　3）选取与当前点距离最小的k个点</p>
<p>　　4）确定这k个点所在类别的出现频率</p>
<p>　　5）返回这K个点出现频率最高的类别作为当前点的预测分类</p>
<div>
<pre class="prettyprint linenums"> import numpy as np

 # 读取数据<br />
 def file2matrix(filename):<br />
     fr = open(filename)<br />
     arrayLines = fr.readlines()<br />
     numbersOfArray = len(arrayLines)

     df = np.zeros((numbersOfArray, 3))<br />
     classLabel = []<br />
     index = 0

     for line in arrayLines:<br />
         # 截取掉所有的回车字符<br />
         line = line.strip()<br />
         # 使用\t将上一步得到的整行数据切分成一个元素列表<br />
         listFromLine = line.split('\t')<br />
         df[index] = listFromLine[0:3]<br />
         classLabel.append(listFromLine[-1])<br />
         index +=1

     return df, classLabel<br />
 filename = '\datingTestSet.txt'<br />
 df, classLabel = file2matrix(filename)</pre>
</div>
<h3>2. KNN缺点：</h3>
<p>（1）KNN算法是基于实例的学习，使用算法时我们必须有接近实际数据的训练样本数据。KNN必须保存全部数据集，如果训练数据集的很大，必须使用大量的存储空间。</p>
<p>（2）必须对数据集中的每个数据计算距离值，耗时非常大</p>
<p>（3）它无法给出任何数据的基础结构信息， 因此我们无法知晓平均实例样本和典型事例样本具有什么特征</p>
<h2>二. 使用sklearn.neighbors</h2>
<div>
<pre class="prettyprint linenums"> from sklearn import neighbors<br />
 import numpy as np

 x = np.array([[-1, -1], [-2, -1], [-3, -2], [1, 1], [2, 1], [3, 2]])<br />
 y = [1, 1]<br />
 nbr = neighbors.NearestNeighbors(n_neighbors=2, algorithm='auto').fit(x)<br />
 distance, indices = nbr.kneighbors(y)</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1030344/201611/1030344-20161117152030685-112358413.png" /></p>
<p>最近邻算法主要分为三种：</p>
<h3>（1）Brute Force</h3>
<ul><li>对于N个实例在D维中，枚举计算，时间复杂度：<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/757e6525671255d8689148b8b5d1fb62403f0d5e.png" /></li>
<li>随着N增加，时间消耗相当大</li></ul>
<h3>（2）K-D tree</h3>
<h4>1.&nbsp;<strong>什么叫做K_Dtree</strong>：</h4>
<p>K：K邻近查询中的k；D：空间是D维空间（Demension）tree：二叉树</p>
<p>　　</p>
<h4>2.&nbsp;<strong>建树过程</strong>：</h4>
<p>K-D tree的建立就是<strong>分裂空间</strong>的过程</p>
<ul><li>首先我们来定义树节点的状态：</li></ul>
<p>分裂点（split_point）</p>
<p>分裂方式（split_method）</p>
<p>左儿子（left_son）</p>
<p>右儿子（right_son）</p>
<ul><li><strong>建树依据：</strong></li></ul>
<p>　　先计算当前区间 [ L , R ] 中（这里的区间是点的序号区间，而不是我们实际上的坐标区间），每个点的坐标的每一维度上的方差，取方差最大的那一维，设为 d，作为我们的分裂方式（split_method ），把区间中的点按照在 d 上的大小，从小到大排序，取中间的点 sorted_mid 作为当前节点记录的分裂点，然后，再以 [ L , sorted_mid-1 ] 为左子树建树 ， 以 [sorted_mid+1 , R ] 为右子树建树，这样，当前节点的所有状态我们便确定下来了：</p>
<p>split_point= sorted_mid</p>
<p>split_method= d</p>
<p>left_son = &nbsp;[ L , sorted_mid-1 ]</p>
<p>right_son = &nbsp;[ sorted_mid+1 , R ]</p>
<ul><li><strong>举例：</strong></li></ul>
<p>　　假设现在我们有平面上的点集 E ，其中有 5 个二维平面上的点 ： （1,4）（5,8） （4,2） （7,9） （10，11）</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1030344/201611/1030344-20161117155609654-707458668.png" /></p>
<p>首先，我们对整个区间 [1 , 15] 建树：先计算区间中所有点在第一维（也就是 x 坐标）上的方差：</p>
<p>　　平均值 ： ave_1 =5.4</p>
<p>　　方差 ： varance_1 =9.04</p>
<p>再计算区间中所有点在第二维（也就是 y 坐标）上的方差：</p>
<p>　　平均值：ave_2 =6.8</p>
<p>　　方差：varance_2 =10.96</p>
<p>明显看见，varance_2 &gt; varance_1 ，那么我们在本次建树中，分裂方式 ：split_method =2&nbsp;， 再将所有的点按照第2维的大小从小到大排序，得到了新的点的一个排列：</p>
<p>（4,2） （1,4）（5,8）&nbsp;（7,9） （10,11）</p>
<p>取中间的点作为分裂点 sorted_mid =（5，8）作为根节点，再把区间 [1 , 2] 建成左子树 , [4 , 5] 建成右子树，此时，直线 ： y = 8 将平面分裂成了两半，前面一半给左儿子，后面一半给了右儿子，如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1030344/201611/1030344-20161117155846170-2097522431.png" /></p>
<p>建左子树 [1, 3] 的时候可以发现，这时候第一维的方差大 ，分裂方式就是1&nbsp;，把区间 [ 1, 2 ] 中的点按照 第一维 的大小，从小到大排序 ，取中间点（1,4）&nbsp;根节点，再以区间 [ 2, 2] 建立右子树 得到节点 （4,2）</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1030344/201611/1030344-20161117155941357-1762516215.png" /></p>
<p>建右子树 [4 , 5] 的时候可以发现，这时还是第一维的方差大， 于是，我们便得到了这样的一颗二叉树 也就是 K-D tree，它把平面分成了如下的小平面，使得每个小平面中最多有一个点：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1030344/201611/1030344-20161117160009248-791689748.png" /></p>
<h4><strong>3. 查询过程：</strong></h4>
<p>　　查询，其实相当于我们要将一个点&ldquo;添加&rdquo;到已经建好的 K-D tree 中，但并不是真的添加进去，只是找到他应该处于的子空间即可，所以查询就显得简单的。</p>
<p>　　每次在一个区间中查询的时候，先看这个区间的分裂方式是什么，也就是说，先看这个区间是按照哪一维来分裂的，这样如果这个点对应的那一维上面的值比根节点的小，就在根节点的左子树上进行查询操作，如果是大的话，就在右子树上进查询操作。</p>
<p>　　每次回溯到了根节点（也就是说，对他的一个子树的查找已经完成了）的时候，判断一下，以该点为圆心，目前找到的最小距离为半径，看是否和分裂区间的那一维所构成的平面相交，要是相交的话，最近点可能还在另一个子树上，所以还要再查询另一个子树，同时，还要看能否用根节点到该点的距离来更新我们的最近距离。为什么是这样的，我们可以用一幅图来说明：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1030344/201611/1030344-20161117160247154-1447475003.png" /></p>
<p>　　在查询到左儿子的时候，我们发现，现在最小的距离是 r = 10 ，当回溯到父亲节点的时候，我们发现，以目标点（10,1）为圆心，现在的最小距离 r = 10 为半径做圆，与分割平面 y = 8 相交，这时候，如果我们不在父亲节点的右儿子进行一次查找的话，就会漏掉（10,9） 这个点，实际上，这个点才是距离目标点 （10,1） 最近的点</p>
<p>　　由于每次查询的时候可能会把左右两边的子树都查询完，所以，查询并不是简单的 log(n) 的，最坏的时候能够达到 sqrt(n)</p>
<h4>4. 在对样本实例进行KD-tree算法</h4>
<p>KD（K-dimensional tree）树形结构。KD tree是二叉树</p>
<ul><li>原理：如果我们知道A与B非常近，B与C非常近，我们就假定认为A与C非常近，不用确切的计算出他们的距离</li>
<li>计算复杂度：&nbsp;<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/b9b92f23dce9bff3b9b0f68f3051f307da0fa7d9.png" /></li>
<li>对参数空间沿着数据轴（N）进行划分，KDtree 很高效，因为划分过程是在参数轴（N）上进行，而不用管D实例维数</li>
<li>但是只有当D很小（D&lt;20）的时候，运算块，当D大时，计算也会变慢</li>
<li>对于上面代码，只需修改,algorithm='KDTree'</li></ul>
<div>
<pre class="prettyprint linenums"> nbr = neighbors.NearestNeighbors(n_neighbors=2, algorithm='KDTree').fit(x)</pre>
</div>
<h3>（3）Ball tree</h3>
<h4>　　1. 原理：</h4>
<p>　　为了改进KDtree的二叉树树形结构，并且沿着笛卡尔坐标进行划分的低效率，ball tree将在一系列嵌套的超球体上分割数据。也就是说：使用超球面而不是超矩形划分区域。虽然在构建数据结构的花费上大过于KDtree，但是在高维甚至很高维的数据上都表现的很高效。</p>
<p>　　球树递归地将数据划分为由质心C和半径r定义的节点，使得节点中的每个点都位于由r和C定义的超球内。通过使用三角不等式来减少邻居搜索的候选点数量的</p>
<p><img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/e184e57ed29688d6164835e952cebb8d0a68657a.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1030344/201611/1030344-20161117162946092-514145471.png" /></p>
<h4>2. 划分</h4>
<p>　　选择一个距离当前圆心最远的观测点i1，和距离i1最远的观测点&nbsp;i2，将圆中所有离这两个点最近的观测点都赋给这两个簇的中心，然后计算每一个簇的中心点和包含所有其所属观测点的最小半径。对包含n个观测点的超圆进行分割，只需要线性的时间。　　</p>
<p><strong>3. 查询</strong></p>
<p>　　使用ball&nbsp;tree时，先自上而下找到包含target的叶子结点（c, r），从此结点中找到离它最近的观测点。这个距离就是最近邻的距离的上界。检查它的兄弟结点中是否包含比这个上界更小的观测点。方法是：如果目标点距离兄弟结点的圆心的距离 &gt; 兄弟节点所在的圆半径 + 前面的上界的值，则这个兄弟结点不可能包含所要的观测点。否则，检查这个兄弟结点是否包含符合条件的观测点。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1030344/201611/1030344-20161117165941123-825776876.png" /></p>
<p>如果：该点的最近距离上确界+兄弟节点的半径 &gt; 该点到兄弟节点圆心的距离，则表明构成了三角形，两个圆必然相交</p>
<h4>4. 在对样本实例进行ball tree算法</h4>
<ul><li>对于上面代码，只需修改,algorithm='ball_tree'</li></ul>
<div>
<pre class="prettyprint linenums">nbr = neighbors.NearestNeighbors(n_neighbors=2, algorithm='ball_tree').fit(x)</pre>
</div>
<h3>（4）选择何种算法</h3>
<h4>1. 各算法时间复杂度：N:样本数量，D:特征向量</h4>
<ul><li><em>Brute force</em>&nbsp;query time grows as&nbsp;<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/75043d4d5bf1dc90a2f7ea3a1c487ca5db2919fb.png" /></li>
<li><em>Ball tree</em>&nbsp;query time grows as approximately&nbsp;<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/974c5f1d8585eb528dfe40e806e691b93d32fcce.png" /></li>
<li><em>KD tree</em>&nbsp;query time changes with&nbsp;<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/3cf5aa5abe312e6fd4996975341a43aa566e8d8d.png" />&nbsp;in a way that is difficult to precisely characterise. For small&nbsp;<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/3cf5aa5abe312e6fd4996975341a43aa566e8d8d.png" />&nbsp;(less than 20 or so) the cost is approximately&nbsp;<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/37e9375fd0210ca33a205eba70c66ba4b41ddc96.png" />, and the KD tree query can be very efficient. For larger&nbsp;<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/3cf5aa5abe312e6fd4996975341a43aa566e8d8d.png" />, the cost increases to nearly&nbsp;<img referrerpolicy="no-referrer"src="http://scikit-learn.org/dev/_images/math/b1b02908acc20145bfec9cde71e0ee5ab4881b69.png" />, and the overhead due to the tree structure can lead to queries which are slower than brute force.</li></ul>
<p>对于小数据集（N小于30左右）， log（N）可以与N比较，并且强力算法可以比基于树的方法更有效。KDTree和BallTree都通过提供叶大小参数来解决这个问题：这控制了查询切换到暴力的样本数。 这允许两个算法接近小于N的强力计算的效率。</p>
<h4>2. 数据结构：</h4>
<p>数据的内在维度或数据的稀疏性。 内在维度是指数据所在的D，其可以线性地或非线性地嵌入参数空间中。 稀疏性指的是数据填充参数空间的程度（这与&ldquo;稀疏&rdquo;矩阵中使用的概念区分开来。数据矩阵可以没有零项，但是结构在这个项中仍然可以是&ldquo;稀疏的&rdquo; ）。</p>
<ul><li>强制查询时间根据数据结构不变。</li>
<li>ball tree和KD树查询时间会受到数据结构的很大影响。 一般来说，具有较小固有维度的稀疏数据导致更快的查询时间。 由于KD树内部表示与参数轴对齐，因此对于任意结构化数据，它通常不会显示与ball tree相同的改进。</li></ul>
<p>机器学习中使用的数据集往往是非常结构化的，非常适合基于树的查询。</p>
<h4>3. 可以自动选择：</h4>
<div>
<pre class="prettyprint linenums">nbr = neighbors.NearestNeighbors(n_neighbors=2, algorithm='auto').fit(x)</pre>
</div>
<p>目前，如果k &lt;N / 2并且'effective_metric_'在'kd_tree'的'VALID_METRICS'列表中，algorithm ='auto'选择'kd_tree'。 如果k &lt;N / 2并且'effective_metric_'不在'kd_tree'的'VALID_METRICS'列表中，它选择'ball_tree'。 如果k&gt; = N / 2，则选择&ldquo;brute&rdquo;。 该选择基于如下假设：查询点的数量至少与训练点的数量相同，并且该leaf_size接近其默认值30。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1l0gz8.html">添加Web引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z3mmnq.html">压缩文本、字节或者文件的压缩辅助类-GZipHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gr71lq.html">实战手记：让百万级数据瞬间导入SQL Server</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e6gmxq.html">ccc prefab</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypw6gq.html">Android Studio 的安装和配置篇（Windows篇）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1o4vv9.html">Camel routes in Spring config file</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1j7569.html">【转载】eclipse调试arm裸机程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ywdeeq.html">LightOJ 1197 Help Hanzo 素数筛</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y5wdnq.html">windows 8 vpn 错误解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwrgzq.html">【留坑】uva12299</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde24509.html">LINUX服务器配置NFS服务，挂载外部存储实现目录共享</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmnl2e9.html">Qt多线程编程总结（一）（所有GUI对象都是线程不安全的）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zzmz09.html">&lbrack;原创&rsqb; linux 下上传 datapoint数据到yeelink 【golang版本】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdwokk9.html">教你用Perl 实现Base64编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpne6j9.html">求求别再这么用log4x了</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyrm5z9.html">CMake必知必会</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m0rzn8.html">Algorithm --&amp;gt&semi; 全排列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1pkvzq.html">结合Socket实现DDoS攻击</a>
		</li>
						<li><a href="https://www.batexi.com/a/90moo7j8.html">CAS tomcat6搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwypdd8.html">python字典遍历的几种方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8kgey39.html">C&num; 多线程详解 Part&period;01（UI 线程、子线程）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kgxy79.html">转载部长一篇大作：常用排序算法之JavaScript实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8elnleq.html">【日期-时间】Java中Calendar的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd4m4jq.html">zookeeper系列之通信模型&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwm7vk8.html">&lbrack;HTML5&rsqb;原生事件绑定和jquery动态事件绑定的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwm7gy8.html">Electron实战：创建ELectron开发的window应用安装包</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96rjv39.html">delphi 常用的将窗口置前的函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96rpm49.html">HDFS--&lpar;HA&rpar;初始化与启动</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8egywx9.html">创建线程方式-NSThread</a>
			</li>
						<li><a href="https://www.batexi.com/a/495e0609.html">git学习系列--六分之一</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
